#!/usr/local/bin/python
#
# $Id: //projects/cage/diamonds.py#6 $ $Date: 2002/07/21 $

"""
A simple reduction automaton that generates diamond patterns.
"""

import curses

import cage


class DiamondsAutomaton(cage.SynchronousAutomaton):
    states = 2
    DEAD, ALIVE = range(states)

    def __init__(self, size):
        cage.SynchronousAutomaton.__init__(self, cage.VonNeumannMap(size))

    def rule(self, address):
        return reduce(lambda x, y: x or y, self.map.states(address))


def main(stdscr):
    try:
        player = cage.CursesPlayer(stdscr)
        automaton = DiamondsAutomaton(player.size)
        cage.SeedInitializer(5).initialize(automaton)
        player.main(automaton)
    finally:
        player.done()

if __name__ == '__main__': curses.wrapper(main)
