#!/usr/local/bin/python
#
# $Id: //projects/cage/parity.py#6 $ $Date: 2002/07/21 $

"""
An implementation of a trivial parity rule as a reduction automaton.
"""

import curses
import operator

import cage


def main(stdscr):
    try:
        player = cage.CursesPlayer(stdscr)
        automaton = cage.TwoStateReductionAutomaton(player.size, \
                                                    operator.xor)
        cage.SeedInitializer(5).initialize(automaton)
        player.main(automaton)
    finally:
        player.done()

if __name__ == '__main__': curses.wrapper(main)
